import create from 'dd-store'
import pageStore from './store';
import { checkFullScren } from "../../utils/checkFullScren";
import { selectPeople, selectedelRequired } from "../../utils/utils";
import { modifySchedule, addSchedule, getUserScheduleInTime, getHomeUserSchedule } from '../../api/request.js'


create.Page({
  store: pageStore,
  useAll: true,
  data: {
    $data: null,
    scheduleItem: '',
    // 登陆当前账户的人 权限
    currentPeople: '',
    isIPX: false
  },
  onLoad(event) {
    // this.reset()
    if (event.scheduleItem) {
      event.scheduleItem = decodeURIComponent(event.scheduleItem)
      let scheduleItem = JSON.parse(event.scheduleItem)
      this.setData({
        scheduleItem: scheduleItem
      })

      let contactPeople = []
      let contactPeopleId = []
      for (let value of this.$store.data.participatorList) {
        contactPeople.push(value)
        contactPeopleId.push(value.userId)
      }
      this.store.data.contactPeople = contactPeople
      this.store.data.contactPeopleId = contactPeopleId
      this.update()
    }
    this.setData({
      isIPX: checkFullScren(),
      currentPeople: getApp().globalData.userid
    })
  },
  onShow() {
    this.getParticipatorLength()
  },
  // 添加参会人 钉钉选人  
  addParticipator() {
    let require = []
    let select = []

    // 创建的 可选 必选
    if (!this.data.scheduleItem) {
      require = [getApp().globalData.userid]
      select = selectedelRequired(Object.keys(this.$store.data.participatorList), require)
    }
    // 编辑 发起人的可选必选
    else if (this.$store.data.originalData.organizer === getApp().globalData.userid) {
      select = this.store.data.contactPeopleId
      require = [getApp().globalData.userid]
    }
    // 编辑 参会人可选必选
    else {
      select = this.store.data.contactPeopleId
      require = [...this.$store.data.originUsersId]
    }
    selectPeople(select, require).then(res => {
      const participatorList = {}
      if (!this.data.scheduleItem) {
        participatorList[getApp().globalData.userid] = {
          userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk'
        }
        for (let i = 0; i < res.users.length; i++) {
          participatorList[res.users[i].userId] = { userId: res.users[i].userId, username: res.users[i].name, headUrl: res.users[i].avatar, platform: 'dingtalk' }
        }
        this.$store.data.participatorList = participatorList
        this.$store.data.showParticipatorList = Object.values(participatorList)
        this.update()
      }
    })
  },
  // 删除参会人
  delParticipants(event) {
    let userId = event.target.dataset.userId
    const participatorList = { ...this.$store.data.participatorList }
    const showParticipatorList = [...this.$store.data.showParticipatorList]
    delete participatorList[userId]
    for (let i = 0; i < showParticipatorList.length; i++) {
      if (showParticipatorList[i].userId === userId) {
        showParticipatorList.splice(i, 1)
      }
    }
    this.$store.data.participatorList = participatorList
    this.$store.data.showParticipatorList = showParticipatorList
    this.update()
    this.getParticipatorLength()
  },
  // // 编辑时候的保存
  // editSave() {
  //   if (JSON.stringify(this.$store.data.originUsers) != JSON.stringify(this.store.data.contactPeople)) {
  //     this.$store.data.updateInfo.isUpate = true
  //     this.$store.data.updateInfo.updateType = 'operate_user'
  //     this.$store.data.participatorList = this.store.data.contactPeople
  //     this.$store.data.participatorUserId = this.store.data.contactPeopleId
  //     this.update()
  //   }
  //   dd.navigateBack({
  //     delta: 1
  //   })
  // },

  // // 保存信息
  // saveInfo() {
  //   this.editSave()
  // },
  // 获取参会人长度
  getParticipatorLength() {
    const length = this.$store.data.showParticipatorList.length
    dd.setNavigationBar({
      title: `参会人(${length}人）`
    })
  },
  // 重置参会人
  // reset() {
  //   this.store.data.contactPeople = []
  //   this.store.data.contactPeopleId = []
  //   this.update()
  // },


});
